package my.vaadin.app;

import java.util.ArrayList;
import java.util.List;

import com.vaadin.flow.component.Unit;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.checkbox.Checkbox;
import com.vaadin.flow.component.grid.Grid;
import com.vaadin.flow.component.notification.Notification;
import com.vaadin.flow.component.orderedlayout.VerticalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.renderer.ComponentRenderer;
import com.vaadin.flow.router.Route;

/**
 * The main view contains a button and a click listener.
 */
@Route
public class MainView extends VerticalLayout {

	public MainView() {
		// buttonDemo();
		// fullClassGridDemo();
		 partClassGridDemo();
		// stringGridDemo();
		// stylesDemo();
	}

	private void buttonDemo() {
		TextField textField = new TextField();
		Button button = new Button("Say hello", event -> Notification.show("Hello, " + textField.getValue()));
		add(textField);
		add(button);
	}

	private void fullClassGridDemo() {
		List<Person> persons = new ArrayList<>();
		persons.add(new Person("Ivan", "Ivanov", 26, true));
		persons.add(new Person("Petar", "Petrov", 30, true));
		persons.add(new Person("Maria", "Martinova", 28, false));
		
		Grid<Person> grid = new Grid<>(Person.class);
		grid.setItems(persons);
		add(grid);
	}

	private void partClassGridDemo() {
		List<Person> persons = new ArrayList<>();
		persons.add(new Person("Ivan", "Ivanov", 26, true));
		persons.add(new Person("Petar", "Petrov", 30, true));
		persons.add(new Person("Maria", "Martinova", 28, false));

		
		Grid<Person> grid = new Grid<>();
		grid.addColumn(p -> p.getFirstName() + " " + p.getLastName()).setHeader("Name");

		grid.addColumn(Person::getAge).setHeader("Age");
		
		grid.addColumn(new ComponentRenderer<>(person -> {
			Checkbox checkbox = new Checkbox();
			checkbox.setEnabled(false);
			checkbox.setValue(person.isMen());
			return checkbox;
		})).setHeader("Men");

		grid.setItems(persons);
		add(grid);
	}

	private void stringGridDemo() {
		Grid<String> grid = new Grid<>(String.class);
		List<String> names = new ArrayList<>();
		names.add("Ivan");
		names.add("Petar");
		grid.setItems(names);
		add(grid);
	}

	private void stylesDemo() {
		setClassName("main-view");
		setWidth("200px");
		setHeight(200, Unit.PIXELS);
	}
}
